import org.garret.jipc.*;

class Message implements java.io.Serializable {
    int    ivalue;
    String svalue;

    Message(int i) { 
	svalue = Chat.hello;
	ivalue = i;
    }
}

/**
 * Test for queue with broadcasts
 * Usage: start N processes by "java Chat N ID" command, where ID = 0,1,...,N-1
 * Output: none
 */
public class Chat extends JIPCTest { 
    static final int    nIterations = 1000;
    static final String hello = "Hello world";

    public static void main(String args[]) throws Exception { 
	if (args.length < 2) { 
	    System.out.println("Usage: java Shmem <number-of-participants> <id>"); 
	    return;
	}
	int nParticipants = Integer.parseInt(args[0], 10);
	int id = Integer.parseInt(args[1], 10);

	JIPCSession session = createSession();
	JIPCBarrier barrier = session.createBarrier("chat", nParticipants);
	JIPCQueue queue = session.createQueue("chat");

	barrier.waitFor();
	int checksum = 0;
	for (int i = 0; i < nIterations; i++) { 	    
	    int msgid = id + i*nParticipants;
	    queue.broadcast(new Message(msgid));
	    checksum += msgid;
	    for (int j = 1; j < nParticipants; j++) { 	    
		Message msg = (Message)queue.get();
		Assert.that(msg.svalue.equals(hello));
		checksum += msg.ivalue;
	    }
	}
	Assert.that(checksum == nIterations*nParticipants*(nIterations*nParticipants-1)/2);
	session.close();
    }
}
