import java.io.*;
import java.util.*;
import java.lang.reflect.Method;


public class SpawnTests extends Thread { 
    static class ProcOutputReader extends Thread { 
	ProcOutputReader(InputStream in) { 
	    this.in = in;
	}
        public void run() { 
	    byte buf[] = new byte[1024];
	    int rc;
	    try { 
		while ((rc = in.read(buf)) > 0) { 
		    synchronized(System.out) { 
			System.out.print(new String(buf, 0, rc));
			System.out.flush();
		    }
		}
	    } catch (Exception x) {
		x.printStackTrace();
	    }
	}
	InputStream in;
    }



    public void run() {
	try { 
	    if (mainMethod != null) { 
		Object args[] = new Object[1];
		args[0] = cmd;
		mainMethod.invoke(null, args);
	    } else { 
		Process proc = Runtime.getRuntime().exec(cmd);
		ProcOutputReader stdoutReader = new ProcOutputReader(proc.getInputStream());
		ProcOutputReader stderrReader = new ProcOutputReader(proc.getErrorStream());		
		stderrReader.start();
		stdoutReader.run();
		stdoutReader.join();
		proc.waitFor();
	    }
	} catch (Exception x) {
	    x.printStackTrace();
	}
    }

    SpawnTests(int id, ArrayList cmdLine) { 
	cmd = (String[])cmdLine.toArray(new String[cmdLine.size() + 1]);
	cmd[cmd.length-1] = Integer.toString(id);
    }

    public static void main(String args[]) throws Exception {
	if (args.length < 2) { 
	    System.out.println("Usage: java SpawnTests CLASS N_PROCESSES");
	    System.exit(1);
	}
	int nProcesses = Integer.parseInt(args[1]);
	SpawnTests thread[] = new SpawnTests[nProcesses];

	Iterator iterator = System.getProperties().entrySet().iterator();
	ArrayList cmdLine = new ArrayList();

	String port = System.getProperty("jipc.port");
	boolean multithreaded = port == null || port.length() == 0;
	String className = args[0];

	if (multithreaded) { 
	    Class mainClass = Class.forName(className);
	    Class mainParams[] = new Class[1];
	    mainParams[0] = args.getClass();
	    mainMethod = mainClass.getMethod("main", mainParams);
	} else { 
	    cmdLine.add("java");
	    while (iterator.hasNext()) { 
		Map.Entry entry = (Map.Entry)iterator.next();
		String propName = (String)entry.getKey();
		if (propName.startsWith("jipc.")) { 
		    cmdLine.add("-D" + propName + "=" + entry.getValue());
		}
	    }
	    cmdLine.add(className);
	}
	cmdLine.add(args[1]);

	long start = System.currentTimeMillis();

	for (int i = 0; i < nProcesses; i++) { 
	    thread[i] = new SpawnTests(i, cmdLine);
	    thread[i].start();
	}
	
	for (int i = 0; i < nProcesses; i++) { 
	    thread[i].join();
	}

	System.out.println("Elapsed time: " + (System.currentTimeMillis() - start) + " milliseconds");
    }

    static Method mainMethod;
    static String className;
    String cmd[];
}

